"use strict";
var _a, _b, _c, _d, _e;
Object.defineProperty(exports, "__esModule", { value: true });
class SuperApp {
    static initial(key) {
        console.log("SuperApp is initialized with " + key);
    }
    static getInfo() {
        return {
            versionCode: 1,
            versionName: "1.0.0a",
            buildServer: "dev",
        };
    }
    static initialReact() {
        window.addEventListener(this.React.Device.CashDrawer.EVENT_CASHDRAWER_OPEN, function (e) {
            SuperApp.Device.CashDrawer.open(e.detail.requestId);
        });
        window.addEventListener(this.React.Device.Printer.EVENT_PRINTER_PRINT, function (e) {
            console.log("Receive printer:" + e.detail.printData);
            SuperApp.Device.Printer.print(e.detail.printData);
        });
    }
}
exports.default = SuperApp;
(() => {
    console.log("SuperApp is created");
})();
SuperApp.React = (_a = class {
    },
    _a.Device = (_b = class {
        },
        _b.CashDrawer = (_c = class {
                static open(requestId) {
                    window.dispatchEvent(new CustomEvent(this.EVENT_CASHDRAWER_OPEN, {
                        detail: {
                            requestId: requestId
                        }
                    }));
                }
                static getStatus() {
                    return "open|close|undefined";
                }
                static setCashDrawerEventListener(listener) {
                    SuperApp.Device.CashDrawer.listener = listener;
                    window.addEventListener(this.EVENT_CASHDRAWER_EVENT, function (e) {
                        SuperApp.Device.CashDrawer.listener(e.detail.action, e.detail.requestId);
                    });
                }
            },
            _c.EVENT_CASHDRAWER_OPEN = "SuperApp.Device.CashDrawer.open",
            _c.EVENT_CASHDRAWER_EVENT = "SuperApp.Device.CashDrawer.event",
            _c),
        _b.Printer = (_d = class {
                static print(printData, printingListener) {
                    console.log("Prepare send printer:" + JSON.stringify(printData));
                    window.dispatchEvent(new CustomEvent(this.EVENT_PRINTER_PRINT, {
                        detail: {
                            printData: JSON.stringify(printData)
                        }
                    }));
                    SuperApp.Device.Printer.printingListener = printingListener;
                    window.addEventListener(this.EVENT_PRINTER_PRINTING_EVENT, function (e) {
                        SuperApp.Device.Printer.printingListener(e.detail.action);
                    });
                }
                static getStatus() {
                    return "normal|connect_fail|out_of_paper|undefined";
                }
                static setPrinterStatusListener(statusListener) {
                    SuperApp.Device.Printer.statusListener = statusListener;
                }
            },
            _d.EVENT_PRINTER_PRINT = "SuperApp.Device.Printer.print",
            _d.EVENT_PRINTER_PRINTING_EVENT = "SuperApp.Device.Printer.printingEvent",
            _d),
        _b),
    _a);
SuperApp.MiniApp = class {
    static open(miniAppId, versionCode, data) {
        console.log("miniapp opened.");
        return {
            result: true,
            message: "success|miniapp not exist"
        };
    }
    static getInfo(miniAppId) {
        return {
            result: true,
            message: "success|miniapp not exist",
            version: "1.0.4",
            name: "sale",
            displayName: "ขายสินค้า",
            lastUpdate: "2022-11-09T05:25:47Z"
        };
    }
    static requestShowOnCustomerDisplay(htmlPath) {
        console.log("requestShowOnCustomerDisplay.");
    }
    static requestHideFromCustomerDisplay() {
        console.log("requestHideFromCustomerDisplay.");
    }
    static broadcastDataToCustomerDisplay(data) {
        console.log("Broadcast with " + data);
    }
    static getData() {
        return "data request by call()";
    }
    static finish(data) {
        console.log("Finish activity and return data");
    }
};
SuperApp.Terminal = class {
    static getInfo() {
        return {
            terminalId: "1x121y",
            os: "Android",
            osVersion: "9",
            screenCount: 1,
            screenSize: [{ width: 1024, height: 768 }]
        };
    }
};
SuperApp.Store = class {
    static getInfo() {
        return {
            storeId: "12345",
            storeName: "storeName",
            language: "TH",
            companyId: "01",
        };
    }
};
SuperApp.User = class {
    static getInfo() {
        return {
            userId: "12345",
            userName: "userName",
        };
    }
};
SuperApp.Device = (_e = class {
    },
    _e.CashDrawer = class {
        static open(requestId) {
            console.log("Cash drawer is opened.");
            return true;
        }
        static getStatus() {
            return "open|close|undefined";
        }
        static setCashDrawerEventListener(listener) {
            SuperApp.Device.CashDrawer.listener = listener;
        }
    },
    _e.Printer = class {
        static print(printData) {
            console.log("printData =>", printData);
        }
        static setPrintingStatusListener(printingListener) {
            SuperApp.Device.Printer.printingListener = printingListener;
        }
        static getStatus() {
            return "normal|connect_fail|out_of_paper|undefined";
        }
        static setPrinterStatusListener(statusListener) {
            SuperApp.Device.Printer.statusListener = statusListener;
        }
    },
    _e);
